SystemOrganization addCategory: #'Test-TP-Metaprogramacion'!

Object subclass: #MockDelegatorClass
	instanceVariableNames: 'intVar stringVar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!MockDelegatorClass class methodsFor: 'creation' stamp: 'Ariel 11/4/2013 00:47'!
create

	| instance |
	instance := MockDelegatorClass new.
	instance initialize.
	^ instance .! !

!MockDelegatorClass methodsFor: 'initialize' stamp: 'Ariel 11/4/2013 01:22'!
initialize 

	intVar := 5.
	stringVar := 'hello'.! !

!MockDelegatorClass methodsFor: 'accessing' stamp: 'Ariel 11/4/2013 01:19'!
intVar
	
	^ intVar! !

!MockDelegatorClass methodsFor: 'accessing' stamp: 'Ariel 11/4/2013 01:19'!
intVar: anObject
	
	intVar := anObject! !

!MockDelegatorClass methodsFor: 'methods' stamp: 'Ariel 11/4/2013 01:29'!
sayHello
	^ nil! !

!MockDelegatorClass methodsFor: 'accessing' stamp: 'Ariel 11/4/2013 01:19'!
stringVar
	
	^ stringVar! !

!MockDelegatorClass methodsFor: 'accessing' stamp: 'Ariel 11/4/2013 01:19'!
stringVar: anObject
	
	stringVar := anObject! !

Object subclass: #MockInterfaceClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!MockInterfaceClass methodsFor: 'private' stamp: 'Ariel 11/3/2013 18:27'!
removeAllMethodsNotPrivate

	|private methods|
	private := #removeAllMethodsNotPrivate.
	methods := self class selectors .
	methods reject: [ :m | m == private ].
	methods do: [ :m | self class removeSelector: m ].! !

TestCase subclass: #TestIVDelegator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!TestIVDelegator methodsFor: 'methods' stamp: 'Ariel 11/4/2013 00:56'!
before
	"This method initialize the object mock to work with this"
	
	| interface |
	mock = MockDelegatorClass create.
	interface := Interface create: Set new.
	interface addUnimplementedMethod: #sayHello in: MockDelegatorClass . ! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 14:59'!
test_sendMessageWithArguments_andSendToObject

	| delegator mock |
	self before.
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	delegator sendMessage: #stringVar: withArguments: #('aValue').
	
	self should: [ delegator object  stringVar = 'aValue' ]! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 15:09'!
test_sendMessageWithArguments_andSendToStringVar

	| delegator mock result |
	self before.
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	result := delegator sendMessage: #asUppercase withArguments: #().
	
	self should: [ result = 'HELLO' ]! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 14:40'!
test_sendMessageWith_andSendToIntVar

	| result delegator mock |
	self before.
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	result := delegator sendMessage: #raisedTo: with: 2.
	
	self should: [ result = 25 ]! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 14:46'!
test_sendMessageWith_andSendToObject

	| delegator mock |
	self before.
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	delegator sendMessage: #stringVar: with: 'aValue'.
	
	self should: [ delegator object  stringVar = 'aValue' ]! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 01:16'!
test_sendMessage_andSendToIntVar

	| result delegator mock|
	self before .
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	result := delegator sendMessage: #squared.
	
	self should: [ result == 25 ].
	! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 01:13'!
test_sendMessage_andSendToObject

	| result delegator mock|
	self before .
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	result := delegator sendMessage: #sayHello.
	
	self should: [ result == nil ].
	! !

!TestIVDelegator methodsFor: 'tests' stamp: 'Ariel 11/4/2013 01:29'!
test_sendMessage_andSendToStringVar

	| result delegator mock|
	self before .
	mock := MockDelegatorClass create.
	delegator := IVDelegator on: mock.
	
	result := delegator sendMessage: #asUppercase.
	
	self should: [ result = 'HELLO' ].
	! !

TestCase subclass: #TestInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Test-TP-Metaprogramacion'!

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/4/2013 00:32'!
test_addNeededStubIn_andAddMethod2

	| interface setOfMethods |
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockInterfaceClass.
	
	interface addNeededStubIn: MockInterfaceClass.
	
	self should: [ MockInterfaceClass canUnderstand: #method2 ].
	
	MockInterfaceClass removeSelector: #method2.
	MockInterfaceClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/4/2013 00:32'!
test_isComplaint_andReturnFalse

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockInterfaceClass .

	self should: [ (interface isCompliant: MockInterfaceClass) not ].
	MockInterfaceClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/4/2013 00:32'!
test_isComplaint_andReturnTrue

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockInterfaceClass .

	self should: [ interface isCompliant: MockInterfaceClass ].
	MockInterfaceClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/4/2013 00:32'!
test_isUnderstoodBy_andReturnFalse

	|interface mock setOfMethods|
	mock:= MockInterfaceClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockInterfaceClass . 
	
	self should: [ (interface isUnderstoodBy: mock) not]! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/4/2013 00:32'!
test_isUnderstoodBy_andReturnTrue

	|interface mock setOfMethods|
	mock:= MockInterfaceClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockInterfaceClass . 
	
	self should: [ interface isUnderstoodBy: mock ]! !
